package ccc.gateway;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.InputStreamReader;
import java.io.Reader;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.drools.RuleBase;
import org.drools.RuleBaseFactory;
import org.drools.WorkingMemory;
import org.drools.compiler.PackageBuilder;
import org.drools.rule.Package;

/**
 * Servlet implementation class for Servlet: CallRules
 */
 public class CallRules extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
   static final long serialVersionUID = 1L;
    /* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#HttpServlet()
	 */
	public CallRules() {
		super();
	}   
	
	private static RuleBase readRule() throws Exception {
		//read in the source		
		Reader	source = new InputStreamReader(Executor.class.getResourceAsStream("/Sample.drl"));
		PackageBuilder builder = new PackageBuilder();
		builder.addPackageFromDrl( source );
		Package pkg = builder.getPackage();
		RuleBase ruleBase = RuleBaseFactory.newRuleBase();
		ruleBase.addPackage( pkg );
		return ruleBase;
	}
	public static class Message {
		public static final int HELLO = 0;
		public static final int GOODBYE = 1;
		
		private String message;
		
		private int status;
		
		public String getMessage() {
			return this.message;
		}
		
		public void setMessage(String message) {
			this.message += "\n"+message;
		}
		
		public int getStatus() {
			return this.status;
		}
		
		public void setStatus( int status ) {
			this.status = status;
		}
		public void Afficher( String msg ) {
			this.status = status;
		}
		
	}
    
	  public void init() {
		  try {
	            RuleBase ruleBase = readRule();
	            WorkingMemory workingMemory = ruleBase.newStatefulSession();           
	            Message message = new Message();
	            message.setMessage(  "Gestion fianciere" );
	            message.setStatus( Message.HELLO );
	            workingMemory.insert( message );
	            workingMemory.fireAllRules();              
	        } catch (Throwable t) {
	            t.printStackTrace();
	        }
	  }
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		doPost(request, response);
	}  

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		response.setContentType("text/html");
		PrintWriter out = response.getWriter();	
		out.println("<HTML>");
		out.println("<HEAD><TITLE> Mortimer  </TITLE></HEAD>");
		out.println("<BODY><h1>");
		out.println("i'm alive!!");
		out.println("</h1></BODY>");
		out.println("</HTML>");	
		out.close(); 
	    }
}   	  	    
